VCMD0028040700000000COMPONENT          
Node "rSimResource"
{
Name "DominosCreator"
Id 1
NodeClass 
{
Id 1
Feature "rPlaneFeature"
{
Name "Plane"

Visible 1
VariableSpace
{
  Variable "rTVariable<rString>"
  {
    Name "Name"
    Value "Plane"
    Group 0
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group 1
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTExpressionVariable<rDouble>"
  {
    Name "Size"
    Value
    {
      Expression "150.00 {mm}"
    }
    Group 2
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      MANAGED
    }
  }
}
Size 
{
  Expression "150.00 {mm}"
}

}
VCID "6afec682-5769-4bd9-a27d-a6f9da26a424"
}
Functionality "rPythonScript"
{
Id 1
Name "PythonScript"
Visible 1
Script "from vcScript import *
\nfrom PIL import Image
\nimport vcVector, vcMatrix
\n
\ndef OnCreate(arg):
\n  app.ProgressValue = 0.0
\n  app.ProgressStatus = \"Creating ...\"
\n  
\n  OnClear(None)
\n
\n  domino = comp.Domino
\n  spacing = max(domino.DominoX, domino.DominoY)
\n  
\n  image = Image.open(comp.ImageFile[8:]) 
\n  pixels = image.load()
\n  
\n  app.ProgressValue = 0.5
\n  ProgressStatus = \"Reading image ...\"
\n  
\n  for yIndex in range(image.size[1]):
\n    for xIndex in range(image.size[0]):
\n      
\n      #app.ProgressValue += 0.89/image.size[0]/image.size[1]
\n      #app.ProgressStatus = \"Pixel \" + str(xIndex) + \", \" + str(yIndex)
\n      
\n      clone = app.cloneComponent(domino)
\n      matrix = vcMatrix.new()
\n      matrix.translateAbs(xIndex*spacing, yIndex*spacing, 0.0)
\n      matrix.rotateRelZ(45.0)
\n      if yIndex == 0 and xIndex == 0:
\n        matrix.rotateRelY(9.0)
\n      clone.PositionMatrix = matrix
\n      
\n      materialName = \"Domino_\" + str(pixels[xIndex, yIndex][0]) + \"_\" + str(pixels[xIndex, yIndex][1]) + \"_\" + str(pixels[xIndex, yIndex][2])
\n      material = app.findMaterial(materialName)
\n      if not material:
\n        material = copyMaterial('blue', pixels[xIndex, yIndex][0]/255.0, pixels[xIndex, yIndex][1]/255.0, pixels[xIndex, yIndex][2]/255.0) 
\n        material.Name = materialName
\n        app.addMaterial(material)
\n      
\n      clone.Material = material
\n 
\n  app.ProgressValue = 1.0
\n  app.ProgressStatus = \"Done\"
\n
\ndef OnClear(arg):
\n  for child in app.Components:
\n    if \"Domino #\" in child.Name:
\n      child.delete()
\n
\n
\ndef copyMaterial(original_name, r=0, g=0, b=0): 
\n  name_of_the_copy = original_name+'_copy' 
\n  
\n  # find the materialname matching the given name 
\n  orig_material = app.findMaterial( original_name ) 
\n  
\n  # create new material or use existing one 
\n  new_material = app.findMaterial( name_of_the_copy ) 
\n  if not new_material: new_material = app.createMaterial( name_of_the_copy ) 
\n  
\n  # copy all properties from the original 
\n  new_material.Ambient = vcVector.new(r,g,b)
\n  new_material.ColorMask = orig_material.ColorMask 
\n  new_material.Diffuse = vcVector.new(r,g,b)
\n  new_material.Specular = orig_material.Specular 
\n  new_material.Shininess = orig_material.Shininess 
\n  new_material.Opacity = orig_material.Opacity 
\n  new_material.OpacityType = orig_material.OpacityType 
\n  if orig_material.Texture: new_material.Texture = orig_material.Texture 
\n  new_material.TextureMapping = orig_material.TextureMapping 
\n  new_material.LineWidth = orig_material.LineWidth 
\n  new_material.LineStippling = orig_material.LineStippling 
\n  new_material.StipplingPattern = orig_material.StipplingPattern 
\n  new_material.StipplingScale = orig_material.StipplingScale 
\n  new_material.RenderOrder = orig_material.RenderOrder 
\n  new_material.DepthComparison = orig_material.DepthComparison 
\n  
\n  # adds material into the group of registered materials. 
\n  # Returns False if a material with the same name already exists. 
\n  app.addMaterial( new_material ) 
\n  return new_material 
\n
\n
\napp = getApplication()
\ncomp = getComponent()
\ncreate = comp.getProperty(\"Create\")
\ncreate.OnChanged = OnCreate
\nclear = comp.getProperty(\"Clear\")
\nclear.OnChanged = OnClear
\n"
CompatibilityMode 0
}
VCID 6afec682-5769-4bd9-a27d-a6f9da26a424
OriginalUri file:///C:/Users/EricsCh1/Documents/Visual+Components/4.7/My+Models/DominosCreator.vcmx
Revision 0
Location 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
ActiveSimulationLevel detailed
BOMname  "NewComponent"

BOMdescription  ""

Category  ""

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rUri>"
  {
    Name "ImageFile"
    Value "file:///D:/Mario_Small.jpg"
    Group 11
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTVariable<rButton>"
  {
    Name "Create"
    Value 0
    Group 20
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
  Variable "rTPointerVariable<Component>"
  {
    Name "Domino"
    Value "Domino"
    Group 10
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
    }
  }
  Variable "rTVariable<rButton>"
  {
    Name "Clear"
    Value 0
    Group 30
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
}
}
